/*  wx_flame engine version 2.0	    

    This file is part of the WidgetX library
    http://www.dynamic-core.net
*/

function wx_flame(w,h,tx,ty){
	this.id = "wx_flame"+(wx_flame.Count++)
	this.object = this.id + "Obj"
	eval(this.object + "=this")

	this.spots=2
	this.tilesx=tx
	this.tilesy=ty
	this.tw=Math.round(w/tx)
	this.th=Math.round(h/ty)
	this.timerid=null
	this.running=false
	this.autoflame=false

	this.setSize((this.tw*tx)+2,(this.th*ty)+2)
	this.setVisible(false)

	this.palette = new Array()
	DynFunctions.createRedPal(this.palette)

	return this
}
wx_flame.Count=0
wx_flame.prototype = new DynLayer
wx_flame.prototype.getSubClass = function() { return wx_flame }
wx_flame.prototype.setFlame=function(b) { this.autoflame=b }
wx_flame.prototype.onCreate=function() {
		this.setBgColor('#ffffff')

		this.evlyr=new DynLayer()
		this.evlyr.moveTo(1,1)
		this.evlyr.setSize((this.tw*this.tilesx),(this.th*this.tilesy))
		this.evlyr.setVisible(true)

		this.events=new EventListener(this)
		this.events.onmousemove=function(e){
			me=e.getTarget()
			targx=Math.round((e.getX()-(me.tw/2))/me.tw)
			targy=Math.round((e.getY()-(me.th/2))/me.th)
			me.fcol[targx+(me.tilesx*targy)]=255
		}

		this.evlyr.addEventListener(this.events)

		this.flyr = new Array()
		this.fcol = new Array()
		for (var x=0; x<this.tilesx; x++) for (var y=0; y<this.tilesy; y++) {
			this.fcol[x+(this.tilesx*y)]=0
			this.flyr[x+(this.tilesx*y)]=new DynLayer()
			this.flyr[x+(this.tilesx*y)].setBgColor(this.palette[this.fcol[x+(this.tilesx*y)]])
			this.flyr[x+(this.tilesx*y)].setSize(this.tw,this.th)
			this.flyr[x+(this.tilesx*y)].moveTo(1+(x*this.tw),1+(y*this.th))
			this.flyr[x+(this.tilesx*y)].setVisible(true)
			this.addChild(this.flyr[x+(this.tilesx*y)])
		}
		for (var x=0; x<this.tilesx; x++) {
			c=Math.round(Math.random()*2)	
			if (c>0) c=255
			this.fcol[x+(this.tilesx*(this.tilesy-1))]=c;
		}

		DynFunctions.getColor(255,64,128)

		this.addChild(this.evlyr)
	}
wx_flame.prototype.update=function(){
	fire=this.flyr
	col=this.fcol
	pal=this.palette
	tx=this.tilesx
	ty=this.tilesy

	for (var y=0; y<ty-1; y++) for (var x=0; x<tx; x++) {
			if (x==0) col[x+(tx*y)]=Math.round((col[(x+1)+(tx*y)]+col[x+(tx*(y+1))])/3.1)
			else if (x==tx-1) col[x+(tx*y)]=Math.round((col[(x-1)+(tx*y)]+col[x+(tx*(y+1))])/3.1)
			else col[x+(tx*y)]=Math.round((col[(x-1)+(tx*y)]+col[(x+1)+(tx*y)]+col[x+(tx*(y+1))])/3.1)
	}
	max=ty*tx
	for (var y=0; y<max; y++) if (is.ns4) fire[y].doc.bgColor=pal[col[y]]
	else fire[y].css.backgroundColor=pal[col[y]]


	ty=tx*(ty-1)
	for (var x=0; x<tx; x++) col[x+ty]=0
	tx-=1
	al=this.spots
	if (this.autoflame) for (var i=0; i<al; i++) col[Math.round(Math.random()*tx)+ty]=255

	if (is.ns) this.timerid = setTimeout(this.object+'.update()',25)
}
wx_flame.prototype.start = function () { 
	this.stop()

	if (is.ns) this.timerid = setTimeout(this.object+'.update()',25)
	else this.timerid = setInterval(this.object+'.update()',25) 
	this.running=true
}
wx_flame.prototype.stop = function () { 
	if(this.running)
		if (is.ns) clearTimeout(this.timerid)
		else clearInterval(this.timerid)
	this.running = false
}
wx_flame.prototype.remove=function(){
	for (var x=0; x<this.tilesx; x++) for (var y=0; y<this.tilesy; y++) this.flyr[x+(this.tilesx*y)].deleteFromParent()
	this.deleteFromParent()
}
