/*  wx_vector version 2.0	    

    thanks to Rob Breeds for his help 

    This file is part of the WidgetX library
    http://www.dynamic-core.net
*/

function wx_vectors(x,y,w,h){
	this.id = "wx_vectors"+(wx_vectors.Count++)
	this.object = this.id + "Object"
	eval(this.object + "=this")

	this.lsin=new Array
	this.lcos=new Array
	DynFunctions.sintable(this.lsin)
	DynFunctions.costable(this.lcos)
	
	this.moveTo(x||0,y||0)
	this.setSize(w||260,h||260)
	this.wxvectorssetVisible(false)

	this.xoffset=this.w>>1
	this.yoffset=this.h>>1

	this.oldx=w>>1
	this.oldy=h>>1

	this.points=new Array()
	this.target=new Array()
	this.dlyr=new Array()

	return this
}
wx_vectors.Count=0
wx_vectors.prototype = new DynLayer()
wx_vectors.prototype.xrot=0
wx_vectors.prototype.yrot=0
wx_vectors.prototype.zrot=0
wx_vectors.prototype.xrotspeed=2
wx_vectors.prototype.yrotspeed=4
wx_vectors.prototype.zrotspeed=6
wx_vectors.prototype.defsrc=''
wx_vectors.prototype.defw=32
wx_vectors.prototype.defh=32
wx_vectors.prototype.timerid = null
wx_vectors.prototype.running = false
wx_vectors.prototype.mouserotate=false
wx_vectors.prototype.mousex=this.xrot
wx_vectors.prototype.mousey=this.yrot
wx_vectors.prototype.mouseoldx=0
wx_vectors.prototype.mouseoldy=0
wx_vectors.prototype.getSubClass=function() { return wx_vectors }
wx_vectors.prototype.wxvectorssetVisible=DynLayer.prototype.setVisible
wx_vectors.prototype.setVisible=function(b) {
		this.wxvectorssetVisible(b)
		this.rotate()
		this.draw()
	}
wx_vectors.prototype.onCreate=function() {
		this.controll=new DynLayer
		this.controll.setSize(this.w,this.h)
		this.controll.moveTo(0,0)
		
		this.events=new EventListener(this)
		this.events.onmousedown=function(e){
			me=e.getTarget()
			me.mouseoldx=e.x
			me.mouseoldy=e.y
			me.mouserotate=true
			e.cancelBubble=false
		}
		this.events.onmouseup=function(e){
			me=e.getTarget()
			me.mouserotate=false
			e.cancelBubble=false
		}
		this.events.onmousemove=function(e){
			me=e.getTarget()
			if (me.mouserotate) {
				if (e.x!=me.mouseoldx && e.y!=me.mouseoldy) {
					if (e.y<me.mouseoldy) me.zrot-=4
					else me.zrot+=4
				}
				if (e.x<me.mouseoldx) me.yrot-=4
				if (e.x>me.mouseoldx) me.yrot+=4
				if (e.y<me.mouseoldy) me.xrot-=4
				if (e.y>me.mouseoldy) me.xrot+=4
			
				if (me.xrot>360) me.xrot-=360
				if (me.yrot>360) me.yrot-=360
				if (me.zrot>360) me.zrot-=360
				if (me.xrot<0) me.xrot+=360
				if (me.yrot<0) me.yrot+=360
				if (me.zrot<0) me.zrot+=360
			
				me.mouseoldx=e.x
				me.mouseoldy=e.y
				me.rotate()
				me.draw()
			}
			e.cancelBubble=false
		}

		this.addChild(this.controll)
		this.controll.css.zIndex=2000
	}
wx_vectors.prototype.useMouse=function(b) {
		if (b) this.controll.addEventListener(this.events)
		else this.controll.removeEventListener(this.events)
	}	
wx_vectors.prototype.setDefaultImg=function(src,w,h){
	this.defsrc=src
	this.defw=w
	this.defh=h
}
wx_vectors.prototype.add=function(x,y,z,src,w,h) {
	src=src||this.defsrc
	w=w||this.defw
	h=h||this.defh
	var i=this.points.length
	this.points[i]=new DynFunctions.tpoint()
	this.target[i]=new DynFunctions.tpoint()
	this.points[i].x=x||0
	this.points[i].y=y||0
	this.points[i].z=z||0
	this.target[i].x=x||0
	this.target[i].y=y||0
	this.target[i].z=z||0

	this.dlyr[i]=new DynLayer()
	this.dlyr[i].setHTML('<img src="'+src+'" width="'+w+'" height="'+h+'" name="'+this.id+i+'">')
	this.dlyr[i].setSize(w<<1,h<<1)
	this.dlyr[i].setVisible(true)

	this.addChild(this.dlyr[i])
}
wx_vectors.prototype.rotate=function() {
	obj=this.points
	al=obj.length
	for (var i=0; i<al;i++){
		xrotcos=this.lcos[this.xrot]
		xrotsin=this.lsin[this.xrot]
		yrotcos=this.lcos[this.yrot]
		yrotsin=this.lsin[this.yrot]
		zrotcos=this.lcos[this.zrot]
		zrotsin=this.lsin[this.zrot]

		x=obj[i].x
		y=obj[i].y
		z=obj[i].z

		// z-ax
		y2=zrotcos*y-zrotsin*x
		x=zrotcos*x+zrotsin*y

		// x-ax
		this.target[i].y=xrotcos*y2+xrotsin*z
		z=xrotcos*z-xrotsin*y2

		// y-ax
		this.target[i].x=yrotcos*x-yrotsin*z
		this.target[i].z=yrotsin*x+yrotcos*z
	}
}
wx_vectors.prototype.draw=function() {
	var dcss=null
	var targ=null
	var al=this.target.length
	for (var i=0; i<al; i++) {
		targ=this.target[i]
		z=targ.z
		dcss=this.dlyr[i].css
		dcss.zIndex=1000-z
		z=((-256)/((-256)-z))

		if (is.ns) {
			dcss.left=this.xoffset+(targ.x*z)-(this.dlyr[i].w>>1)
			dcss.top=this.yoffset+(targ.y*z)-(this.dlyr[i].h>>1)
		} else {
			dcss.pixelLeft=this.xoffset+(targ.x*z)-(this.dlyr[i].w>>1)
			dcss.pixelTop=this.yoffset+(targ.y*z)-(this.dlyr[i].h>>1)
		}
	}
}
wx_vectors.prototype.update=function() {
	// draw and rotate
	var obj=this.points
	var al=this.target.length
	var dcss=null
	var targ=null
	for (var i=0; i<al; i++) {
		targ=this.target[i]
		z=targ.z
		dcss=this.dlyr[i].css
		dcss.zIndex=1000-z
		z=((-256)/((-256)-z))
		
		if (is.ns) {
			dcss.left=this.xoffset+(targ.x*z)-(this.dlyr[i].w>>1)
			dcss.top=this.yoffset+(targ.y*z)-(this.dlyr[i].h>>1)
		} else {
			dcss.pixelLeft=this.xoffset+(targ.x*z)-(this.dlyr[i].w>>1)
			dcss.pixelTop=this.yoffset+(targ.y*z)-(this.dlyr[i].h>>1)
		}

		// rotate
		xrotcos=this.lcos[this.xrot]
		xrotsin=this.lsin[this.xrot]
		yrotcos=this.lcos[this.yrot]
		yrotsin=this.lsin[this.yrot]
		zrotcos=this.lcos[this.zrot]
		zrotsin=this.lsin[this.zrot]

		x=obj[i].x
		y=obj[i].y
		z=obj[i].z

		// z-ax
		y2=zrotcos*y-zrotsin*x
		x=zrotcos*x+zrotsin*y

		// x-ax
		targ.y=xrotcos*y2+xrotsin*z
		z=xrotcos*z-xrotsin*y2

		// y-ax
		targ.x=yrotcos*x-yrotsin*z
		targ.z=yrotsin*x+yrotcos*z
	}

	this.xrot=(this.xrot+this.xrotspeed) %360
	this.yrot=(this.yrot+this.yrotspeed) %360
	this.zrot=(this.zrot+this.zrotspeed) %360

	if (is.ns) this.timerid = setTimeout(this.object+'.update()',25)
}
wx_vectors.prototype.start = function () { 
	this.stop()

	if (is.ns) this.timerid = setTimeout(this.object+'.update()',25)
	else this.timerid = setInterval(this.object+'.update()',25)
	this.running=true
}
wx_vectors.prototype.stop = function () { 
	if(this.running)
		if (is.ns) clearTimeout(this.timerid)
		else clearInterval(this.timerid)
	this.running = false
}
wx_vectors.prototype.setSpeed=function (x,y,z) { 
	this.xrotspeed=x
	this.yrotspeed=y
	this.zrotspeed=z
}
wx_vectors.prototype.setRotation=function (x,y,z) {
	this.xrot=x
	this.yrot=y
	this.zrot=z
}
wx_vectors.prototype.addRotation=function (x,y,z) {
	this.xrot+=x; if (this.xrot>360) this.xrot-=360
	this.yrot+=y; if (this.yrot>360) this.yrot-=360
	this.zrot+=z; if (this.zrot>360) this.zrot-=360
}
wx_vectors.prototype.remove = function() { this.deleteFromParent() }