// Copyright (C) 2000 Brandon E. Myers
// Redistributable under the terms of the GNU Library General Public License v2
// These are enhancements to the core DynAPI implementation.
// They are kept seperate untill Dan wishes to incorporate them into the standard Core.

DynAPI.dimension=function(x,y,w,h,s) {
    this.x=x;
    this.y=y;
    this.w=w;
    this.h=h;
    this.source=s||null;
}

FastMath={
    findPoint : function(angle,dist) {
        if (angle==90) return new DynAPI.dimension(0,0,dist,0);
        if (angle==270) return new DynAPI.dimension(0,0,-dist,0);
        if (angle==180) return new DynAPI.dimension(0,0,0,-dist);
        if (angle==0) return new DynAPI.dimension(0,0,0,dist);
        var x1,y1;
        x1=Math.cos(angle)*dist;
        y1=Math.sin(angle)*dist;
        return new DynAPI.dimension(0,0,x1,y1);
    },
    findXOffsets : function(angle,y) { // Find the X offset given length Y
        if (angle==90||angle==270) return new DynAPI.dimension(0,0,0,0);
        if (angle==180||angle==0) return null;
        return (Math.sin(angle)/y)*Math.cos(angle);
    },
    findYOffset : function(angle,x) {
        if (angle==90||angle==270) return null
        if (angle==180||angle==0) return 0
        return (Math.cos(angle)/x)*Math.sin(angle);
    },
    addVectors : function() {
        var x,y,p,l;
        if (typeof(arguments[0])=='array') l=arguments[0]
        else l=arguments;
        for (var i=0;i<l.length;i+=2) {
            p=findPoint(l[i],l[i+1]);
            x+=p.w;
            y+=p.h;
        }
        return makeVector(x,y);
    },
    makeVector : function(x,y) {
        var v=[0,0];
        v[1]=Math.sqrt((x*x)+(y*y)); // Get dist.
        v[0]=Math.acos(x/v[1]); // Get Angle
    }
}

