// Scroll Object
// encapsulate ScrollWindow, ButtonImages and ScrollBars to generate our beloved Scroll object
// by IlMaestro ( ilmaestro@cantir.com )
//
// DynAPI Copyright (C) 2000 Dan Steinman
// Redistributable under the terms of the GNU Library General Public License
// Available at http://www.dansteinman.com/dynapi/

// needs updating

function Scroll(color,margincolor) {
	this.name="Scroll"+Scroll.count++;
	window[this.name]=this

	this.margin=0

	// Layers

	this.component = new DynLayer()	
	this.component.setBgColor(margincolor||"white")	

	this.screenlyr=this.component.add(new DynLayer())
	this.screenlyr.setBgColor(color||"white")	

	this.window = new ScrollWindow(color||"white")
	this.screenlyr.add(this.window)	
	this.window.onScrollStart = new Function(this.name+".onWindowScrollStart()")
	this.window.onScroll = new Function(this.name+".onWindowScroll()")
	this.window.onScrollEnd = new Function(this.name+".onWindowScrollEnd()")
	this.window.moveTo(0,0)
	this.window.getComponent().setZIndex(5)

	this.scrollH = new ScrollBar(0,0,"#DDDDDD")
	this.scrollH.onScroll = new Function(this.name+".scrollTo(arguments[0],null)")
	this.scrollH.onScrollEnd = new Function(this.name+".onWindowScrollEnd()")
	this.scrollH.onScrollStart = new Function(this.name+".onWindowScrollStart()")
	this.screenlyr.add(this.scrollH)	
	this.scrollH.getComponent().setZIndex(3)


	this.scrollV = new ScrollBar(0,0,"#DDDDDD")
	this.scrollV.onScroll = new Function(this.name+".scrollTo(null,arguments[1])")
	this.scrollV.onScrollEnd = new Function(this.name+".onWindowScrollEnd()")
	this.scrollV.onScrollStart = new Function(this.name+".onWindowScrollStart()")
	this.screenlyr.add(this.scrollV)	
	this.scrollV.getComponent().setZIndex(3)

	this.cornerlyr = this.screenlyr.add(new DynLayer())
	this.cornerlyr.setZIndex(1)

	this.Bup = new ButtonImage()
	this.Bup.onMouseDown = new Function(this.name+".window.up()")
	this.Bup.onMouseUp =new Function(this.name+".window.stop()")
	this.screenlyr.add(this.Bup)
	this.Bup.getComponent().setZIndex(3)

	this.Bdown = new ButtonImage()
	this.Bdown.onMouseDown = new Function(this.name+".window.down()")
	this.Bdown.onMouseUp =new Function(this.name+".window.stop()")
	this.screenlyr.add(this.Bdown)
	this.Bdown.getComponent().setZIndex(3)

	this.Bleft = new ButtonImage()
	this.Bleft.onMouseDown = new Function(this.name+".window.left()")
	this.Bleft.onMouseUp = new Function(this.name+".window.stop()")
	this.screenlyr.add(this.Bleft)
	this.Bleft.getComponent().setZIndex(3)


	this.Bright = new ButtonImage()
	this.Bright.onMouseDown = new Function(this.name+".window.right()")
	this.Bright.onMouseUp = new Function(this.name+".window.stop()")
	this.screenlyr.add(this.Bright)
	this.Bright.getComponent().setZIndex(3)

	// Programable events

	this.onScrollStart = new Function()
	this.onScroll = new Function()
	this.onScrollEnd = new Function()
}
Scroll.prototype.getClass = function() {return this.constructor}
Scroll.prototype.getComponent = function() {return this.component}
Scroll.prototype.setMargin = function(m) {this.margin=m; this.setSize(this.w,this.h)}
Scroll.prototype.setTheme = function(dir) {
	this.scrollH.setImages(DynAPI.getImage(dir+'scroll-bgh.gif',100,100),DynAPI.getImage(dir+'scroll-boxh.gif',37,16))
	this.scrollV.setImages(DynAPI.getImage(dir+'scroll-bgv.gif',100,100),DynAPI.getImage(dir+'scroll-boxv.gif',16,37))
	this.cornerlyr.setBgImage(dir+'scroll-corner.gif');
	this.Bup.setImages(DynAPI.getImage(dir+'scroll-up0.gif',16,16),DynAPI.getImage(dir+'scroll-up0.gif',16,16),DynAPI.getImage(dir+'scroll-up1.gif',16,16))
	this.Bdown.setImages(DynAPI.getImage(dir+'scroll-dn0.gif',16,16),DynAPI.getImage(dir+'scroll-dn0.gif',16,16),DynAPI.getImage(dir+'scroll-dn1.gif',16,16))
	this.Bleft.setImages(DynAPI.getImage(dir+'scroll-lt0.gif',16,16),DynAPI.getImage(dir+'scroll-lt0.gif',16,16),DynAPI.getImage(dir+'scroll-lt1.gif',16,16))
	this.Bright.setImages(DynAPI.getImage(dir+'scroll-rt0.gif',16,16),DynAPI.getImage(dir+'scroll-rt0.gif',16,16),DynAPI.getImage(dir+'scroll-rt1.gif',16,16))
}
Scroll.prototype.setSize = function(w,h) {
	this.w = w
	this.h = h
	this.component.setVisible(false)
	this.component.setSize(this.w,this.h)
	this.screenlyr.moveTo(this.margin,this.margin)
	this.scrollV.setSize(-1,this.h-(2*this.margin)-this.scrollH.h-this.Bup.h-this.Bdown.h)
	this.scrollH.setSize(this.w-(2*this.margin)-this.scrollV.w-this.Bleft.w-this.Bright.w,-1)
	this.scrollV.setSize(-1,this.h-(2*this.margin)-this.scrollH.h-this.Bup.h-this.Bdown.h)
	this.screenlyr.setSize(this.w-2*this.margin,this.h-2*this.margin)
	this.window.setSize(this.w-2*this.margin-this.scrollV.w,this.h-2*this.margin-this.scrollH.h)
	this.scrollV.moveTo(this.window.w,this.Bup.h)
	this.scrollH.moveTo(this.Bleft.w,this.window.h)
	this.cornerlyr.setSize(this.scrollV.w,this.scrollH.h)
	this.cornerlyr.moveTo(this.window.w,this.window.h)
	this.checkBars()
	this.component.setVisible(true)
}
Scroll.prototype.reset = function() { this.window.reset() }
Scroll.prototype.onWindowScrollStart = function() {
	this.onScrollStart()
}
Scroll.prototype.onWindowScroll = function() {
	if(this.window.enableVScroll) this.scrollV.setRatio(0,-this.window.contentlyr.y/this.window.availableScrollY)
	if(this.window.enableHScroll) this.scrollH.setRatio(-this.window.contentlyr.x/this.window.availableScrollX,0)
	this.onScroll()
}
Scroll.prototype.onWindowScrollEnd = function() {
	// Redraw if forms inside
	if(this.window.hasForms) 
	 { this.window.getClyr().setVisible(false); 
	   setTimeout(this.name+".window.getClyr().setVisible(true)",0) }

	this.onScrollEnd()
}
Scroll.prototype.scrollTo = function(rx,ry) {
	this.window.scrollTo(rx,ry)
}
Scroll.prototype.setHTML = function(h) { 
	this.window.setHTML(h)
	this.checkBars()
}
Scroll.prototype.checkBars = function() { 
	var v=this.window.enableVScroll
	var h=this.window.enableHScroll
	if(this.intelligentBars) {
	  if(!v && !h)
	    this.window.setSize(this.w-2*this.margin,this.h-2*this.margin)
	  if(!v && h) {	
	    this.window.setSize(this.w-2*this.margin,this.h-2*this.margin-this.scrollH.h)
	    this.scrollH.setSize(this.w-(2*this.margin)-this.Bleft.w-this.Bright.w,-1)  }
	  if(v && !h) {	
	    this.window.setSize(this.w-2*this.margin-this.scrollV.w,this.h-2*this.margin)
	    this.scrollV.setSize(-1,this.h-(2*this.margin)-this.Bup.h-this.Bdown.h)  }
	}
	this.Bup.moveTo(this.window.w,0)
	this.Bdown.moveTo(this.window.w,this.window.h-this.Bdown.h)
	this.Bleft.moveTo(0,this.window.h)
	this.Bright.moveTo(this.window.w-this.Bright.w,this.window.h)

}
Scroll.prototype.intelligentBars = true

Scroll.count=0;
