/*  wx_toolbar version 1.0

    This file is part of the WidgetX library
    http://www.dynamic-core.net
*/

function wx_toolbar(x,y,w,h,dragable,theme) {
	this.id = "wx_toolbar"+(wx_toolbar.Count++)
	this.object = this.id + "Obj"
	eval(this.object + "=this")
	
	this.items=new Array()
	this.dragable=dragable
	
	this.moveTo(x||0,y||0)
	this.setSize(w||0,h||32)
	this.draghandle=new DynLayer()
	this.draghandle.moveTo(0,0)
	this.docked=false
	
	this.theme=theme||''
	
	this.setVisible(false)

	return this
}
wx_toolbar.Count=0
wx_toolbar.prototype = new DynLayer
wx_toolbar.prototype.getSubClass=function() { return wx_toolbar }
wx_toolbar.prototype.background='toolbar.gif'
wx_toolbar.prototype.setDocked=function() {
		var top=0
		for (var i=0; i<this.parent.children.length; i++) {
			if (this.parent.children[i]!=this && this.parent.children[i].getSubClass()==wx_toolbar) {
				if (this.parent.children[i].docked) {
					if (this.parent.children[i].y<this.y && this.parent.children[i].y+this.parent.children[i].h>top) top=this.parent.children[i].y+this.parent.children[i].h
				}
			}
		}
		this.moveTo(0,top)
		this.docked=true
	}
wx_toolbar.prototype.wx_toolbaraddChild=DynLayer.prototype.addChild
wx_toolbar.prototype.addChild=function(widget) { 
		var i=this.items.length
		this.items[i]=widget
		if (i==0) {
			if (this.dragable) this.items[i].moveTo(18,2)
			else this.items[i].moveTo(5,2)
		}
		else this.items[i].moveTo(this.items[i-1].x+this.items[i-1].w,2)
		this.items[i].setHeight(this.h-2)
		this.items[i].setVisible(true)
		this.wx_toolbaraddChild(this.items[i])
	}
wx_toolbar.prototype.onCreate=function() {
		this.setBgImage(this.theme+this.background)

		this.draghandle.setSize(16,this.h)
		this.draghandle.setBgImage(this.theme+'toolbar-drag.gif')
		
		this.moveEvent=new EventListener(this)
			this.moveEvent.ondragstart=function(e) {
				e.setBubble(false)
				var me=e.getTarget()
				if (me.docked) {
					me.docked=false

					for (var i=0; i<me.parent.children.length; i++) {
						if (me.parent.children[i]!=me && me.parent.children[i].getSubClass()==wx_toolbar) {
							if (me.parent.children[i].docked && me.parent.children[i].y>me.y) me.parent.children[i].setDocked()
						}
					}
				}
			}
		
			this.moveEvent.ondragmove=function(e) {
				e.setBubble(false)
				var me=e.getTarget()
				me.setZIndex(0)
				
				var top=0
				for (var i=0; i<me.parent.children.length; i++) {
					if (me.parent.children[i]!=me && me.parent.children[i].getSubClass()==wx_toolbar) {
						if (me.parent.children[i].docked) {
							if ((me.parent.children[i].y % me.h)<=(me.y % me.h)) {
								if (top==0) top=me.parent.children[i].y+me.parent.children[i].h
								else if (me.parent.children[i].y+me.parent.children[i].h>top) top=me.parent.children[i].y+me.parent.children[i].h
							}
						}
					}
				}	
				if (e.pageY-e.y>top-10 && e.pageY-e.y<top+10) {
					me.moveTo(0,top)
					me.docked=true
				} else {
					me.moveTo(e.pageX-e.x,e.pageY-e.y)
					me.docked=false
				}
			}
				
				
			this.moveEvent.ondragend=function(e) {
				e.setBubble(false)
				var me=e.getTarget()
				if (me.docked) {
					for (var i=me.parent.children.length-1; i>=0; i--) {
						if (me.parent.children[i]!=me && me.parent.children[i].getSubClass()==wx_toolbar) {
							if (me.parent.children[i].docked) me.parent.children[i].setDocked()
						}
					}
				}
			}
			
			this.addEventListener(this.moveEvent)
		
		if (this.dragable) {
				this.draghandle.setVisible(true)
				this.draghandle.addEventListener(this.moveEvent)
				DragEvent.enableDragEvents(this)
				
		} else { this.draghandle.setVisible(false) }


		this.wx_toolbaraddChild(this.draghandle)
	}
