/*  wx_window version 1.0

    This file is part of the WidgetX library
    http://www.dynamic-core.net
*/

function wx_window(x,y,w,h,caption,theme) {
	this.id = "wx_window"+(wx_window.Count++)
	this.object = this.id + "Obj"
	eval(this.object + "=this")
	
	this.moveTo(x||0,y||0)
	this.setSize(w||128,h||36)

	this.caption=caption||''
	this.theme=theme||''
	this.setVisible(false)
	
	this.capbar=new DynLayer()
	this.lLeft=new DynLayer()
	this.lTop=new DynLayer()
	this.lRight=new DynLayer()
	this.lBottom=new DynLayer()
	this.canvas=new DynLayer()
	this.closeButton=new DynLayer()
	this.minimizeButton=new DynLayer()
	this.maximizeButton=new DynLayer()

	this.leftItems=new Array()
	this.topItems=new Array()
	this.rightItems=new Array()
	this.bottomItems=new Array()
	
	return this
}
wx_window.Count=0
wx_window.prototype = new DynLayer
wx_window.prototype.getSubClass=function() { return wx_window }
wx_window.prototype.left=2
wx_window.prototype.top=2
wx_window.prototype.right=2
wx_window.prototype.bottom=2
wx_window.prototype.minW=100
wx_window.prototype.minH=100
wx_window.prototype.caption=''
wx_window.prototype.resizeable=false
wx_window.prototype.moveable=true
wx_window.prototype.cbx=0
wx_window.prototype.cby=0
wx_window.prototype.mibx=0
wx_window.prototype.miby=0
wx_window.prototype.mabx=0
wx_window.prototype.maby=0
wx_window.prototype.restoreX=null
wx_window.prototype.restoreY=null
wx_window.prototype.restoreW=null
wx_window.prototype.restoreH=null
wx_window.prototype.onMinimize=function() { }
wx_window.prototype.onMaximize=function() { }
wx_window.prototype.onClose=function() { }
wx_window.prototype.setCaption=function(caption){
		this.caption=caption
		if (this.capbar.created) this.capbar.setHTML('<span class="default">'+this.caption+'</span>')
	}
wx_window.prototype.setCloseButton=function(x,y,w,h){
		this.cbx=x||0
		this.cby=y||0
		this.closeButton.setSize(w||16,h||16)
		this.closeButton.moveTo(this.cbx,this.cby)
		this.closeButton.setHTML('<img src="'+this.theme+'window-close-a.gif" width="'+(w||16)+'" height="'+(h||16)+'" alt="Close window">')
		this.closeButton.setVisible(true)
	}
wx_window.prototype.setMinimizeButton=function(x,y,w,h){
		this.mibx=x||16
		this.miby=y||0
		this.minimizeButton.setSize(w||16,h||16)
		this.minimizeButton.moveTo((this.w-this.mibx),this.miby)
		this.minimizeButton.setHTML('<img src="'+this.theme+'window-minimize-a.gif" width="'+(w||16)+'" height="'+(h||16)+'" alt="Minimize">')
		this.minimizeButton.setVisible(true)
	}
wx_window.prototype.setMaximizeButton=function(x,y,w,h){
		this.mabx=x||16
		this.maby=y||0
		this.maximizeButton.setSize(w||16,h||16)
		this.maximizeButton.moveTo((this.w-this.mabx),this.maby)
		this.maximizeButton.setHTML('<img src="'+this.theme+'window-maximize-a.gif" width="'+(w||16)+'" height="'+(h||16)+'" alt="Maximize">')
		this.maximizeButton.setVisible(true)
	}
wx_window.prototype.setResizeable=function(b) { 
		if (b==null) this.resizeable=true
		else this.resizeable=b
		if (this.created) {
			if (b) this.resize.addEventListener(this.resizeEvent)
			else this.resize.removeEventListener(this.resizeEvent)
		}
	}
wx_window.prototype.setMoveable=function(b) { 
		this.moveable=b
		if (this.created) {
			if (b) DragEvent.enableDragEvents(this.capbar)
			else DragEvent.disableDragEvents(this.capbar)
		}
	}
wx_window.prototype.onCreate=function() {
		this.capbar.moveTo(this.left,0)
		
		this.resize=new DynLayer()
		this.resize.moveTo(this.w-this.right,this.h-this.bottom)
		this.resize.setSize(this.right,this.bottom)

		this.moveEvent=new EventListener(this)
			this.moveEvent.ondragmove=function(e) {
				e.setBubble(false)
				var me=e.getTarget()
				me.setZIndex(0)
				me.moveTo(e.pageX-e.x,e.pageY-e.y)
				me.capbar.moveTo(me.left,0)
			}
			this.capbar.addEventListener(this.moveEvent)
		
		this.resizeEvent=new EventListener(this)
			this.resizeEvent.ondragstart=function(e) { e.getTarget().setBgColor('#c0c0c0') }
			this.resizeEvent.ondragmove=function(e) {
				e.setBubble(false)
				var me=e.getTarget()
				me.w=e.pageX-me.x
				me.h=e.pageY-me.y
				if (me.w<me.minW) me.w=me.minW
				if (me.h<me.minH) me.h=me.minH
				me.setSize(me.w,me.h)
				me.resize.moveTo(me.w-me.right,me.h-me.bottom)
			}
			this.resizeEvent.ondragend=function(e) {
				var me=e.getTarget()
				me.setBgColor(null)
				me.repaint()
			}
			
		if (this.resizeable) this.resize.addEventListener(this.resizeEvent)

		this.closeEvent=new EventListener(this)
			this.closeEvent.onmouseup=function(e) {
				e.setBubble(false)
				var me=e.getTarget()
				me.setVisible(false)
				me.onClose()
			}
			this.closeButton.addEventListener(this.closeEvent)

		this.minimizeEvent=new EventListener(this)
			this.minimizeEvent.onmouseup=function(e) {
				e.setBubble(false)
				var me=e.getTarget()
				if (!me.restoreX) me.minimize()
				else me.restore()
				me.onMinimize()
			}
			this.minimizeButton.addEventListener(this.minimizeEvent)
		this.maximizeEvent=new EventListener(this)
			this.maximizeEvent.onmouseup=function(e) {
				e.setBubble(false)
				var me=e.getTarget()
				if (!me.restoreX) me.maximize()
				else me.restore()
			}
			this.maximizeButton.addEventListener(this.maximizeEvent)
		
		this.canvas.moveTo(this.left>>1,this.top>>1) //this.left,this.top)

		this.lLeft.moveTo(0,0)
		this.lLeft.setVisible(true)
		this.lTop.setVisible(true)
		this.lRight.setVisible(true)
		this.lBottom.setVisible(true)

		this.repaint()

		this.j4fwindowaddChild(this.canvas)
		this.j4fwindowaddChild(this.lLeft)
		this.j4fwindowaddChild(this.lTop)
		this.j4fwindowaddChild(this.lRight)
		this.j4fwindowaddChild(this.lBottom)
		this.j4fwindowaddChild(this.capbar)
		this.j4fwindowaddChild(this.resize)
		this.j4fwindowaddChild(this.closeButton)
		this.j4fwindowaddChild(this.minimizeButton)
		this.j4fwindowaddChild(this.maximizeButton)
		
		DragEvent.enableDragEvents(this.resize)
		if (this.moveable) DragEvent.enableDragEvents(this.capbar)
	}
wx_window.prototype.restore=function() {	
		if (!this.restoreX) return
		this.setSize(this.restoreW,this.restoreH)
		this.moveTo(this.restoreX,this.restoreY)
		this.restoreX=null
		this.setVisible(true)
		this.repaint()
	}
wx_window.prototype.minimize=function() {	
		this.restoreX=this.x
		this.restoreY=this.y
		this.restoreW=this.w
		this.restoreH=this.h
		this.setVisible(false)
		this.repaint()
		this.onMinimize()
	}
wx_window.prototype.maximize=function() {
		this.restoreX=this.x
		this.restoreY=this.y
		this.restoreW=this.w
		this.restoreH=this.h
		this.setSize(this.parent.w,this.parent.h)
		this.moveTo(0,0)
		this.repaint()
		this.onMaximize()
	}
wx_window.prototype.close=function() {
		this.setVisible(false)
		this.onClose()
	}
wx_window.prototype.j4fwindowaddChild=DynLayer.prototype.addChild
wx_window.prototype.addChild=function(wdg) { this.canvas.addChild(wdg) }
wx_window.prototype.addLeftImage=function(w,h,stretch) {
		i=this.leftItems.length
		this.leftItems[i]=new Array()
		this.leftItems[i].stretch=stretch
		this.leftItems[i].w=w||0
		this.leftItems[i].h=h||0
		if (w>this.left) this.left=w
	}
wx_window.prototype.addTopImage=function(w,h,stretch) {
		i=this.topItems.length
		this.topItems[i]=new Array()
		this.topItems[i].w=w||0
		this.topItems[i].h=h||0
		this.topItems[i].stretch=stretch
		if (h>this.top) this.top=h
	}	
wx_window.prototype.addRightImage=function(w,h,stretch) {
		i=this.rightItems.length
		this.rightItems[i]=new Array()
		this.rightItems[i].w=w||0
		this.rightItems[i].h=h||0
		this.rightItems[i].stretch=stretch
		if (w>this.right) this.right=w
	}
wx_window.prototype.addBottomImage=function(w,h,stretch) {
		i=this.bottomItems.length
		this.bottomItems[i]=new Array()
		this.bottomItems[i].w=w||0
		this.bottomItems[i].h=h||0
		this.bottomItems[i].stretch=stretch
		if (h>this.bottom) this.bottom=h
	}		
wx_window.prototype.getImageHeight=function(ar,el,total) {
		if (ar=='left') {
			var newH=total
			for (var i=0; i<this.leftItems.length; i++) if (i!=el) newH-=this.leftItems[i].h
			this.leftItems[el].h=newH
		} else {
			var newH=total
			for (var i=0; i<this.rightItems.length; i++) if (i!=el) newH-=this.rightItems[i].h
			this.rightItems[el].h=newH
		}
	}
wx_window.prototype.getImageWidth=function(ar,el,total) {
		if (ar=='top') {
			var newW=total
			for (var i=0; i<this.topItems.length; i++) if (i!=el) newW-=this.topItems[i].w
			this.topItems[el].w=newW
		} else {
			var newW=total
			for (var i=0; i<this.bottomItems.length; i++) if (i!=el) newW-=this.bottomItems[i].w
			this.bottomItems[el].w=newW
		}
	}	
wx_window.prototype.repaint=function() {
		this.lLeft.setSize(this.left,this.h)
		this.lTop.setSize(this.w-(this.left+this.right),this.top)
		this.lRight.setSize(this.right,this.h)
		this.lBottom.setSize(this.w-(this.left+this.right),this.bottom)
		this.lBottom.moveTo(this.left,this.h-this.bottom)
		this.lRight.moveTo(this.w-this.right,0)
		this.lTop.moveTo(this.left,0)
		this.canvas.setSize(this.w-((this.left+this.right)>>1),this.h-((this.top+this.bottom)>>1))
		this.capbar.setSize(this.w-(this.left+this.right),this.top)
		this.capbar.setHTML('<span class="default">'+this.caption+'</span>')
		
		this.closeButton.moveTo(this.mbx,this.mby)
		this.minimizeButton.moveTo((this.w-this.mibx),this.miby)
		this.maximizeButton.moveTo((this.w-this.mabx),this.maby)
		
		tmp=''
		for (var i=0;i<this.leftItems.length;i++) {
			if (this.leftItems[i].stretch) this.getImageHeight('left',i,this.lLeft.h)
			tmp+='<img src="'+this.theme+'window-left-'+parseInt(i+1)+'.gif" width="'+this.leftItems[i].w+'" height="'+this.leftItems[i].h+'"><br>'
		}
		this.lLeft.setHTML(tmp)
		
		tmp='<table border=0 cellpadding=0 cellspacing=0 width=100%><td nowrap>'
		for (var i=0;i<this.topItems.length;i++) {
			if (this.topItems[i].stretch) this.getImageWidth('top',i,this.lTop.w)
			tmp+='<img src="'+this.theme+'window-top-'+parseInt(i+1)+'.gif" width="'+this.topItems[i].w+'" height="'+this.topItems[i].h+'">'
		}
		this.lTop.setHTML(tmp+'</td></table>')
		
		tmp=''
		for (var i=0;i<this.rightItems.length;i++) {
			if (this.rightItems[i].stretch) this.getImageHeight('right',i,this.lRight.h)
			tmp+='<img src="'+this.theme+'window-right-'+parseInt(i+1)+'.gif" width="'+this.rightItems[i].w+'" height="'+this.rightItems[i].h+'"><br>'
		}
		this.lRight.setHTML(tmp)
		
		tmp='<table border=0 cellpadding=0 cellspacing=0 width=100%><td nowrap>'
		for (var i=0;i<this.bottomItems.length;i++) {
			if (this.bottomItems[i].stretch) this.getImageWidth('bottom',i,this.lBottom.w)
			tmp+='<img src="'+this.theme+'window-bottom-'+parseInt(i+1)+'.gif" width="'+this.bottomItems[i].w+'" height="'+this.bottomItems[i].h+'">'
		}
		this.lBottom.setHTML(tmp+'</td></table>')
}