// *******************************************
// **
// ** Author: Brandon E. Myers
// **   Date: I don't know. Umm.. today? 12/01/1997
// ** E-Mail: Brandon_Myers@hotmail.com
// **
// *******************************************
// **
// ** Permission to use this Script is granted provided that
// ** you leave this file fully intact and this disclaimer
// ** is included on any and all pages which use any of the
// ** functions below. Also send an E-mail to me to let me know
// ** that my time was not wasted, and maybe I'll have an updated
// ** version with a lot of nifty new features.
// **
// *******************************************
// **
// ** Requires eventObject.js.
// **
// *******************************************
// ** 
// ** Functions to manipulate client side data using a hidden data frame.
// **
// ** These functions allow multiple dynamic event handeling
// ** AND dynamic prioritizing of events.
// ** 
// *******************************************


var updatePage="setDBRow.asp"; // used only for dynamic set/update.
var dataFrameObj;
var queryPage="doQuery.asp"; // used only for dynamic query.
var disableRSEvents=false;

function quickRS() { // Create a quick, generic, recordset object given it's name and list of columns.
    var i=0;
    var columns=quickRS.arguments;
    if (columns.length<1) return;
    var temp=new recordSet(columns[0]);
    for(i=1;i<columns.length;i++) {
        temp.addColumn(columns[i]);
    }
    return temp;
}


// Internal functions to the recordSet object.

		function _queryServer(dataFrame,columns,table,where) {
            if (this.filtered) return;
			dataFrameObj=dataFrame;
		    var pageText='javascript:"'+"<HTML><BODY BGCOLOR=WHITE><FORM name='queryForm' method=post action='"+queryPage+"'>\\n";
	        pageText+="<INPUT TYPE=hidden name='sourceFrame' value='"+ self.name +"'>\\n";
	        pageText+="<INPUT TYPE=hidden name='methodParm' value='self'>\\n";
	        pageText+="<INPUT TYPE=hidden name='method' value='"+this.name+".getResultSet'>\\n";
	        pageText+="<INPUT TYPE=hidden name='COLUMNS' value="+'\\"'+ columns +'\\"'+">\\n";
	        pageText+="<INPUT TYPE=hidden name='TARGET' value="+'\\"'+ table +'\\"'+">\\n";
	        pageText+="<INPUT TYPE=hidden name='showQuery' value='"+ this.showQuery +"'>\\n";
	        if ((typeof(where)=="string") && (where.length >0)) pageText+="<INPUT TYPE=hidden name='WHERE' value="+'\\"'+ where +'\\"'+">\\n";
		    if (!disableRSEvents) this.event.onUnload.trigger();
		    dataFrame.document.href=(pageText+'</FORM></BODY></HTML>";');
//	        alert(pageText);
		    setTimeout("dataFrameObj.document.queryForm.submit();",250)
		}
		
		function _getResultSet(Frame) { // Get a result set from specified frame
			var i;
			this.rowCount=0;
//			alert(Frame.name);
			for(i=this.columns.length-1;i>=0;i--) { // clear column array.
				this.columns[i]=null;
				this.columns.length--;
			} // Finish clearing column identifiers.
			for(i=this.data.length-1;i>=0;i--) { // clear data array.
				this.data[i]=null;
				this.data.length--;
			} // Finish clearing data.
		    this.changeList=new Object();
			if (Frame.document.data.elements.length<2) { if (!disableRSEvents) this.event.onLoad.trigger();return; }
			var incCount=2; // Increment count for the unique ID.
			if (Frame.document.data.elements[0].name=="UNIQUE_ID") {
				this.unique_colname=Frame.document.data.UNIQUE_ID.value;
				if (Frame.document.data.elements[1].name=="tableName")
					this.tableName=Frame.document.data.tableName.value;
				else this.tableName="";
			}
			else {
				if (Frame.document.data.elements[0].name=="tableName")
					this.tableName=Frame.document.data.tableName.value;
				else this.tableName="";
				this.unique_colname="";
			}
			if (this.unique_colname=="") { // unique ID is the first column
				incCount--;
				this.unique_colname=Frame.document.data.elements[1].name; // get the first name.
			}          
			if (this.tableName=="") { // unique ID is the first column
				incCount--;
				this.tableName="UNKNOWN TABLE NAME"; // get the first name.
			}
			var size=0;
//			alert("Unique_ID:"+this.unique_colname);
//			alert("First Element:"+Frame.document.data.elements[incCount].name);
			if (typeof(Frame.document.data[Frame.document.data.elements[incCount].name].length)=='undefined') {
				size=Frame.document.data.elements.length-incCount;
				rows=1;
			}
			else {
				size=(Frame.document.data.elements.length-incCount)/Frame.document.data[Frame.document.data.elements[incCount].name].length;
				rows=Frame.document.data[Frame.document.data.elements[incCount].name].length;
			}
//			alert("Retrieving Data. COLUMNS:" + size + "  ROWS:"+rows);
			for (i=0;i<size;i++) { //retrieve column names.
				this.columns[i]=Frame.document.data.elements[i+incCount].name;
				if (this.unique_colname==this.columns[i]) this.unique_colnum=i;	
			}
			for (this.rowCount=0;this.rowCount<rows;this.rowCount++) {
				this.data[this.rowCount]=new Object();
				for (i=0;i<size;i++) { //retrieve data.
					this.data[this.rowCount][this.columns[i]]=Frame.document.data.elements[i+(this.rowCount*size)+incCount].value;
//					alert("Data: " + this.columns[i] + "="+Frame.document.data.elements[i+(this.rowCount*size)+incCount].value);
				}
			}
//			alert("Done");
			this.currentRow=0;
		    if (!disableRSEvents) this.event.onLoad.trigger();
//			alert(properties(this.data[0]));
		}
		 

        function _fillRSFromLB(listBox,valueField,textField,clearRS) {
            var i=0;
            var row;
            var validRS=this;
            clearRS=(typeof(clearRS)=='undefined'?false:clearRS);
            clearRS=(typeof(textField)=='boolean'?textField:clearRS);
            if (clearRS) {
                validRS.data=new Array();
                validRS.rowCount=0;
                validRS.currentRow=0;
            }
            for (i=0;i<listBox.options.length;i++) {
                row=validRS.addRow();
                validRS.setValueAt(row,valueField,listBox.options[i].value);
                if (arguments.length==5 || typeof(textField)!='boolean') validRS.setValueAt(row,textField,listBox.options[i].text);
            }
        }
        
		function _getValueAt(row,col) {
			//debug.log("RS:"+this.name+"::getValueAt("+row+","+col+")",debug.METHOD);
            if (typeof(col)=="undefined") {
				col=row;
				row=this.currentRow;
			}
            if (row>=this.rowCount) return null;
            if (this.rowCount>this.data.length) { alert("RowCount:"+this.rowCount+" Data Length:"+this.data.length); return null; }
			if(typeof(col)=='number') col=this.columns[col]; // convert to the column identifier.
			return this.data[row][col];
		}

		function _getValue(col) {
			if(typeof(col)=='number') col=this.columns[col]; // convert to the column identifier.
			return this.data[this.currentRow][col];
		}

		function _getRow(row) {
			if (typeof(row)=="undefined") row=this.currentRow;
		    else {
				this.currentRow=row;
			    if (!disableRSEvents) this.event.onRecordChange.trigger();
			}
			return this.data[row];
		}

		function _getUniqueRow(unique_id,col) {
			if(typeof(col)=='number') col=this.columns[col]; // convert to the column identifier.
			if(typeof(col)=='undefined') col=-1;
            this.currentRow=0;
            return this.getNextUniqueRow(unique_id,col)
		}

		function _getNextUniqueRow(unique_id,col) {
            var i=this.currentRow; // Set starting row.
			while(i<this.rowCount) {
				if(this.data[i][this.unique_colname]==unique_id) {
    				this.currentRow=i;
					if (!disableRSEvents) this.event.onRecordChange.trigger();
					if(col==-1) {  // return the row if a column was not named.
						return this.data[i];
					}
                    else {
     					return this.data[i][col]; // return a single cell if the column was specified.
                    }
			    }
				i++;
			}
			return null; // Return null if item not found.
        }

		function _setValueAt(row,col,value) {
		    if (this.filtered) return false;
			if(typeof(col)=='number') col=this.columns[col]; // convert to the column identifier.
		    if (typeof(this.data[row])=="undefined") this.data[row]=new Object();
		    this.data[row][col]=value;
		    //alert(row+":"+col+"="+this.data[row][col]);
		    var arg=new Object();
		    arg.row=row;
		    arg.col=col;
		    arg.value=value;
		    //if (!disableRSEvents) this.event.onDataChange.trigger(arg);
		    return true;
		}

		function continueUpdate(rsName) {
		    eval(rsName+".updateSet(true)"); // call updateSet from the proper object to complete update...
		}

		function _updateSet(cont) { // updates (row by row) each changed row.
		    if (this.filtered) return false;
		    var i;
		    if (typeof(cont)=="undefined" || cont==false) {
		        if (this.tableName=="UNKNOWN TABLE NAME") return false; // if the table is unknown, we can't update.
		        this.leftToUpdate=this.changeList.length;
		    } else
			if (this.leftToUpdate==0) {
				return false;
		    }
		    this.leftToUpdate--;
		    dataFrameObj.document.close();
		    dataFrameObj.document.clear();
		    dataFrameObj.document.open();
		    var pageText="<HTML><BODY><FORM name='updForm' method=post action='"+updatePage+"?sourceFrame="+self.name+"&method=continueUpdate&methodParm="+this.name+"'>";
		    for (i in this.changeList[this.leftToUpdate]) { // setup columns.
		        if (i=="length") continue;
		        pageText+="<INPUT TYPE=hidden name='column' value='"+i+"'>";
		    }
		        pageText+="<INPUT TYPE=hidden name='table' value='"+this.tableName+"'>";
		    for (i in this.changeList[this.leftToUpdate]) {
		        if (i=="length") continue;
		        pageText+="<INPUT TYPE=hidden name='"+i+"' value='"+ this.changeList[this.leftToUpdate][i]+"'>";
		    }
//		    alert(pageText);
		    dataFrameObj.document.writeln(pageText+"</FORM></BODY></HTML>");
		    dataFrameObj.document.close();
		    dataFrameObj.document.updForm.submit();
		    return true;
		}

		function nextRecord() {
		    if (this.currentRow>=this.rowCount-1) return false;
		    this.currentRow++;
//		    if (!disableRSEvents) this.event.onRecordChange.trigger();
		    return true;
		}

		function previousRecord() {
		    if (this.currentRow<=0) return false;
		    this.currentRow--;
//		    if (!disableRSEvents) this.event.onRecordChange.trigger();
		    return true;
		}

		function firstRecord() {
		    this.currentRow=0;
//		    if (!disableRSEvents) this.event.onRecordChange.trigger();
		    return true;
		}

		function lastRecord() {
		    this.currentRow=this.rowCount-1;
//		    if (!disableRSEvents) this.event.onRecordChange.trigger();
		    return true;
		}

		function filterRS(validFunction,functionData) {
		    var i=0;
		    var myFilter=new recordSet("myFilter",true);
		    if (myFilter==null) alert("Filter is null");
		    myFilter.columns=this.columns;
		    myFilter.filtered=true;
			while(i<this.rowCount) {
				if(validFunction(this.data[i],functionData)) {
				    myFilter.data[myFilter.rowCount++]=this.data[i];
				}
				i++;
			}
		    //if (!disableRSEvents) myFilter.event.onLoad.trigger(); // Although there should not be any events,
											  // this is here just in case future modifications
											  // make default events.
		    return myFilter;
		}

		function newColumn(name) {
		    this.columns[this.columns.length]=name;
		    return this.columns.length-2;
		}

		function newRow() {
		    this.data[this.rowCount]=new Object();
            var j=0;
			for (var i in this.columns) {
				if (i=="length") continue;
				this.data[this.rowCount][this.columns[i]]=(newRow.arguments.length>j?newRow.arguments[j++]:'');
			}
		    return this.rowCount++;
		}

// ********************************************************
// **
// ** Function: removeRow
// **
// ** Synopsis:
// **    removeRow() [row to delete is the current row]
// **    removeRow(row) [Row is zero-based]
// **
// ********************************************************
        function removeRow(row) { // Delete a value from the option list.
        	var j=0;
			if (typeof(row)=="undefined") row=this.currentRow;
        	if (row>=this.rowCount) return false;
    		for (j=row;j<this.rowCount-1;j++) {
                this.data[j]=this.data[j+1];
    		} // End For
    		this.data[j]=null; // Remove the last element. (We are at J+1 from the end loop)
            this.rowCount--;
            return true;
        }

// ********************************************************
// **
// ** Function: rs_sort
// **
// ** Synopsis:
// **    rs_sort(sortFunction, Argument) [row to delete is the current row]
// **
// ** Returns:
// **    recordSet object which is sorted. sortedRecordSet.parent=this recordset.
// **
// ** Description
// **
// **  The sort function should return -1 if row 1 is < row 2,
// **                                   0 if row 1 is = row 2,
// **                                   1 if row 1 is > row 2.
// **
// **   Those are the only limitations. have at it!
// **   Row 1 is the lowest entry and row 2 is the index that's searched.
// **   Row 2 < lowest, the item is skipped and not used.
// ********************************************************

        function rs_sort(sortFunction,arg) {
            var sortRS=this.sortRS=new recordSet("sortRS");
            var lowest,i,j,result,row;
            lowest=0;
            var last=-1;
            this.first();
            for (i=0;i<this.columns.length;i++) sortRS.addColumn(this.columns[i]);
            for (i=0;i<this.rowCount;i++) {
                if (last==-1||sortFunction(this,last,i,arg)<1) lowest=i;
                else continue;
                for (j=0;j<this.rowCount;j++) {
                    //if (j==lowest) continue; // no sence in comparing the same item.
                    result=sortFunction(this,lowest,j,arg);
                    if (result==null) continue; // null means skip all together.
                    if (result==0) {
                        //debug.log("result==0",debug.GENERAL);
                    } else    
                    if (result==1) {
                        //debug.log("result==1",debug.GENERAL);
                        if (last==-1) { 
                            lowest=j;
                            debug.log("Setting lowest=="+j,debug.GENERAL);
                        } else if (sortFunction(this,last,j,arg)==-1) {
                            lowest=j;
                            debug.log("Setting lowest=="+j,debug.GENERAL);
                        }
                    }
                }
                last=lowest;
                debug.log("Adding: idx("+lowest+") task("+this.data[lowest]["task_number"]+")",debug.GENERAL);
                sortRS.data[sortRS.rowCount++]=this.data[lowest]; // make a reference
            }
            sortRS.parent=this;
            return sortRS;
        }

/********  Main Code  ***********/
function recordSet(rsName,filter) {
/**
    if (typeof(filter)=="undefined" && typeof(self[rsName])!="undefined") {  // this object name is reserved, or exists.. do not allow duplicates.
    	for(i=self[rsName].columns.length-1;i>=0;i--) { // clear column array.
    		self[rsName].columns[i]=null;
    		self[rsName].columns.length--;
    	} // Finish clearing column identifiers.
    	for(i=self[rsName].data.length-1;i>=0;i--) { // clear data array.
    		self[rsName].data[i]=null;
    		self[rsName].data.length--;
    	} // Finish clearing data.
    	self[rsName].rowCount=0;
    	self[rsName].currentRow=0;
    	self[rsName].changeList=null;
    	self[rsName].unique_colnum=0;
    	self[rsName].unique_colname="";
    	self[rsName].tableName="";
        return self[rsName];
    } **/
	this.type="recordSet";
	this.name=rsName;
	this.tableName="";
	this.showQuery=false;
	this.filtered=false;
	this.leftToUpdate=0; // The number of updates left.
	this.unique_colname="";
	this.currentRow=0;
	this.unique_colnum=0;
	this.columns=new Array();
	this.data=new Array();
	this.rowCount=0;
    this.sortRS=null;
	this.changeList=null;
	/* This should be replaced with the dynapi event model. */
	if (typeof(eventObj)!='undefined') { // If the eventObject.js file was included.. then this will be processed..
		this.event=new eventObj(this);
		this.event.parent=this;
		this.event.newEventType("onLoad"); // Define object for onLoad event.
		this.event.newEventType("onUnload"); // Define object for onUnload event.
		this.event.newEventType("onDataChange"); // Define object for onDataChange event.
		this.event.newEventType("onRecordChange"); // Define object for onRecordChange event.
	} else { disableRSEvents=false; } // Otherwise disable events for recordsets.
	this.filter=filterRS;
    this.sort=rs_sort;
	this.addRow=newRow;
	this.delRow=removeRow;
    this.fillRSFromLB=_fillRSFromLB;
	this.addColumn=newColumn;
	this.getResultSet=_getResultSet;
	this.getValueAt=_getValueAt;
	this.getValue=_getValue;
	this.getRow=_getRow;
	this.getUniqueRow=_getUniqueRow;
    this.getNextUniqueRow=_getNextUniqueRow;
	this.first=firstRecord;
	this.last=lastRecord;
	this.next=nextRecord;
	this.previous=previousRecord;
	this.setValueAt=_setValueAt;
	this.updateSet=_updateSet;
	this.queryServer=_queryServer;
    this.clearRS=function(x) { this.data=new Array(); this.rowCount=0; this.currentRow=0; }
	//if (typeof(filter)=="undefined") self[rsName]=this; // this is so the code can be in a different frame/window than the object was created from.
	return this;
}

//****************************************************************************************//
//*
//**  End Database routines
//*
//****************************************************************************************//