// ServerTask Object
// a simple direct Javascript to CGI communication scheme
// 2000.06.01

// Copyright (C) 2000 Dan Steinman
// Redistributable under the terms of the GNU Library General Public License
// Available at http://www.dansteinman.com/dynapi/

function ServerTask(url) {
	this.url = url

	this.lyr = new DynLayer()
	DynAPI.document.addChild(this.lyr)
	
	var loadevent = new EventListener(this)
	loadevent.onload = function(e) {
		var lyr = e.getSource()
		var st = e.getTarget()
		var id = lyr.elm.ServerTaskID
		var result = lyr.elm.ServerTaskResult
		if (st.resultFunctions[id]) st.resultFunctions[id](result)
	}
	
	this.lyr.addEventListener(loadevent)
	
	this.resultFunctions = new Array()
	
	this.objectID = "ServerTask"+(ServerTask.objectID++)
	window[this.objectID] = this
}
ServerTask.prototype.toString = function() {return this.objectID}
ServerTask.prototype.doTask = function(command,data,resultFunction) {
	var taskid = this.resultFunctions.length
	this.resultFunctions[taskid] = resultFunction || ServerTask.blank
	
	if (command==null) command = ""
	command = escape(command)

	var datastream = "";
	if (!data) {}
	else if (data.constructor == ServerTaskData) {
		datastream = data.getDataStream()
	}
	else if (typeof(data) == "object") { // array
		var d = new ServerTaskData("list",data);
		datastream = d.getdatastream
	}
	else if (typeof(data) == "string" || typeof(data) == "number") {
		datastream = data
	}
	
	var url = this.url+"?ServerTaskObject="+this.toString()+"&ServerTaskID="+taskid+"&ServerTaskCommand="+command+"&ServerTaskData="+datastream
	this.lyr.loadSource(url)
}
ServerTask.blank = new Function()
ServerTask.objectID = 0


function ServerTaskData(type,data) {
	this.type = type
	this.data = data
}
ServerTaskData.prototype.getDataStream = function() {
	var datastream = ""
	if (this.type=="list" || this.type=="array") {
		for (var i=0;i<this.data.length;i++) {
			var d = this.data[i].replace(/\,/g ,'%comma');
			datastream += escape(d)
			if (i<this.data.length-1) datastream += ","
		}
	}
	return datastream
}
