<?

/*

PEngines Class 0.1 (April 27, 2000)
a customizable search engine front end
http://www.dansteinman.com/php/pengines/

Copyright (C) 1999 Dan Steinman (dan@dansteinman.com)

This is free software under the terms of the GNU General Public License

*/

class PEngines {

	function PEngines($db) {
		$this->db = $db;
		if (!$this->db->tableExists("pengines")) {
			$this->db->query("create table pengines (username VARCHAR(255), engine VARCHAR(255), url VARCHAR(255), action VARCHAR(255), method VARCHAR(255), queryfield VARCHAR(16), inputs VARCHAR(255))");
		}
	}

	function getSavedForms() {
		global $username;
		
		$forms = array();
		
		$result = $this->db->query("select * from pengines where(username=\"$username\")");
		
		while ($row = $this->db->fetch_array($result)) {
			$l = count($forms);
			$forms[$l] = array(
				'formname' => "penginesform$l",
				'engine' => $row['engine'],
				'url' => $row['url'],
				'action' => $row['action'],
				'method' => $row['method'],
				'queryfield' => $row['queryfield'],
				'inputs' => array()
			);

			$inputs = split(' &',$row['inputs']);
			for ($i=0;$i<count($inputs);$i++) {
				$keyval = split('=',$inputs[$i],2);
				$name = $keyval[0];
				$value = $keyval[1];
				$forms[$l]['inputs'][] = array("$name" => $value);
			}
		}
		
		return $forms;
	}
	
	function getHiddenFormsString() {
		$str = "";
		
		$forms = $this->getSavedForms();
	
		for ($i=0;$i<count($forms);$i++) {
			$formname = $forms[$i]['formname'];
			$action = $forms[$i]['action'];
			$method = $forms[$i]['method'];
			$inputs = $forms[$i]['inputs'];
		
			$str .= "\n<form name=\"$formname\" action=\"$action\" method=\"get\">\n";
			for ($j=0;$j<count($inputs);$j++) {
				list($name,$value) = each($inputs[$j]);
				$str .= "<input type=\"hidden\"name=\"$name\" value=\"$value\">\n";
			}
			
			$str .= "</form>";
		}
		return $str;
	}

	function displayEditEngines() {
		global $username;
		print "<h3>Edit Engines for $username</h3>";
		print "<p><a href=\"pengines.php3?command=makeengine\">Make a new search engine</a>";
		
		$forms = $this->getSavedForms();
		
		print '
		<form action=pengines.php3 method=post>
		<input type="hidden" name="command" value="deleteengine">
		<table border=1>
		<tr><td><b>Engine Name</b></td><td><b>Delete</b></td></tr>
		';
		
		for ($i=0;$i<count($forms);$i++) {
			$engine = $forms[$i]['engine'];  // the name of the search engine
			$formname = $forms[$i]['formname'];  // the name of the form to submit
	
			print "<tr><td>$engine</td><td><input type=radio name=\"enginetodelete\" value=\"$formname\"></td></tr>";
		}
		print '
		<tr><td></td><td><input type=submit value="Delete"></td></tr>
		</table>
		</form>
		';
		
		print "<p><a href=\"pengines.php3\">Return to PEngines</a>";
	}

	function deleteEngine() {
		global $username, $enginetodelete;
		$forms = $this->getSavedForms();
		for ($i=0;$i<count($forms);$i++) {
			$engine = $forms[$i]['engine'];
			$formname = $forms[$i]['formname'];
			if ($enginetodelete == $formname) {
				$this->db->query("delete from pengines where(username='$username' && engine='$engine')");
				$this->displayEditEngines();
				$successful = true;
				break;
			}
		}
		if (!$successful) {
			print "Error: no search engine was selected";
		}
	}

	function displayMakeEngine() {
		print '
		<script>
		
		pasteURL = function(url) {
			document.pengines.url.value = url
		}
		
		</script>
		
		<form name=pengines action=pengines.php3 method=post>
		<input type=hidden name=command value=submitmakeengine>
		Enter the URL for the search engine you want an entry for:<br>
		<input name=url value="" size=45><br>
		<input type="submit">
		</form>
		
		<p>Example URL\'s (click on them to paste them into the field above):<p>
		';
		
		$list = array(
			'Yahoo' => 'http://www.yahoo.com',
			'Google' => 'http://www.google.com',
			'Alta Vista' => 'http://www.altavista.com',
			'Lycos' => 'http://www.lycos.com'
		);
		
		while( list($name,$value) = each($list) ) {
			print "<a href=javascript:pasteURL('$value')>$name</a><br>";
		}

		print '<p>Try others that you like';
		print "<p><a href=\"pengines.php3\">Return to PEngines</a>";
	}
	
	function displaySubmitMakeEngine($url) {
		$file = http_get($url);
		$html = html_formatTags($file);
		$forms = html_parseForms($html);
	
		$numforms = count($forms);
		if ($numforms==0) {
			debug("no forms found, try a different URL $url");
		}
		
		print "<h3>Results for $url</h3>";
			
		print '
		
		<p>* Query Field: you must check off which input field is the "query field" for the search engine (the one you type your text into).  This will be the input of the Type "text" or "textarea".

		<script language="JavaScript">

		function submitForm(which) {
			var f = document[which];
			var s = document["submitform"];
			
			if (f.enginename.value == "enter a name") {
				alert("You must enter a unique account name")
				return
			}
			
			s.enginename.value = f.enginename.value
			s.action.value = f.action.value
			s.method.value = f.method.value
			
			if (!f.queryfield.length) {
				s.queryfield.value = f.queryfield.value
			}
			else {
				for (var i=0;i<f.queryfield.length;i++) {
					if (f.queryfield[i].checked) {
						s.queryfield.value = f.queryfield[i].value
						break;
					}
				}
			}
			
			var inputs = f.inputs.value.split(", ")
			var sinputs = "";
			
			for (var i=0;i<inputs.length;i++) {
				if (f[inputs[i]]) {
					var value = ""
					if (f[inputs[i]].value) value = f[inputs[i]].value
					value = value.replace(/&/gi,"&amp;")
					sinputs += inputs[i]+"="+value
					if (i<inputs.length-2) sinputs += " &";
				}
			}
			
			s.inputs.value = sinputs;
			s.submit();
		}
		
		</script>
		
		<form name="submitform" action=pengines.php3 method=post>
		<input type=hidden name=command value=saveengine>
		<input type=hidden name=enginename>
		<input type=hidden name=action>
		<input type=hidden name=method>
		<input type=hidden name=queryfield>
		<input type=hidden name=inputs>
		';
		print "<input type=hidden name=url value=$url></form>";

		for ($i=0;$i<$numforms;$i++) {
			$action = $forms[$i]["action"];
			$method = $forms[$i]["method"];
			$inputs = $forms[$i]["inputs"];

			// fix action field
			if (substr($action,0,7) != "http://") {  //!eregi("\:\/\/",$action)
				$server = eregi_replace("http://","",$url);
				if (ereg("/",$server)) {
					$server = substr($server,0,strrpos($server,"/"));
				}
				$a = $action;
				$action = "http://".$server;
				if ($a[0]!="/") $action .= "/";
				$action .= $a;
			}
			
			$num = count($inputs);
			
			print "
						
			<table border=1 cellpadding=2>
			<form name='form$i' method=post>

			<input type=hidden name='numinputs' value='$num'>
			<input type=hidden name='action' value='$action'>
			<input type=hidden name='method' value='$method'>

			<tr><td><b>Engine Name</b></td><td colspan=3><input name=enginename value='enter a name' size=30></td></tr>
			<tr><td><b>Action</b></td><td colspan=3>$action</td></tr>
			<tr><td><b>Method</b></td><td colspan=3>$method</td></tr>
			<tr><td><b>Input Name</b></td><td><b>Type</b></td><td><b>Default Value</b></td><td><b>Query Field *</b></td></tr>

			";
			
			$input = "";
			
			for ($j=0;$j<count($inputs);$j++) {
				$name = $inputs[$j][0];
				$name = chop($name);
				$name = ltrim($name);
				$type = $inputs[$j][1];
				$value = $inputs[$j][2];
				if ($j==0) $default = " checked=true ";
				else $default = "";
				
				print "<tr><td>$name</td><td>$type&nbsp;</td><td><input name='$name' value='$value' size=20></td><td align=center><input type='radio' name='queryfield' value='$name' $default></td></tr>\n";
				
				$input = "$name, $input";
			}

			print "
			<input type=hidden name='inputs' value=\"$input\">
			<tr><td colspan=4><input type=button value='Save This Engine' onclick=submitForm('form$i')></td></tr>
			</form>
			</table>
			";
		}
		
	}

	function displaySaveEngine() {
		global $username,$enginename,$url,$action,$method,$queryfield,$inputs;
		$inputs = rawurldecode($inputs);

		$this->db->query("delete from pengines where(username=\"$username\" && engine=\"$enginename\")");
		$this->db->query("insert into pengines VALUES(\"$username\",\"$enginename\",\"$url\",\"$action\",\"$method\",\"$queryfield\",\"$inputs\")");
	
		print "
			The following search engine data was saved:<p>
			Engine = $enginename<br>
			URL = $url<br>
			Action = $action<br>
			Method = $method<br>
			Query Field = $queryfield<br>
			Inputs = $inputs<br>
			
			<p><a href='pengines.php3'>Return to Pengines to try it out</a>
		";
	}

	
}

?>
