<?

/*

PStocks Class 0.1 (May 10, 2000)
a stock quote grabber
http://www.dansteinman.com/php/pstocks/

Copyright (C) 1999 Dan Steinman (dan@dansteinman.com)

This is free software under the terms of the GNU General Public License

*/

class PStocks {

	function PStocks($db) {
		$this->db = $db;
		if (!$this->db->tableExists("pstocks")) {
			$this->db->query("create table pstocks (username VARCHAR(255), stocks TEXT)");
		}
	}

	function getQuotes($stocklist) {
		if (!$stocklist) return array();
		while(list($symbol,$name) = each($stocklist)) {
			$symbol = rawurldecode($symbol);
			$symbolstr .= "$symbol";
			if ($i++<count($stocklist)-1) $symbolstr .= "+";
		}
		$lines = http_getAsArray("http://finance.yahoo.com/d/quotes.csv?f=sl1d1t1c1ohgv&e=.csv&s=$symbolstr");

		$quotes = array();
		for ($i=0;$i<count($lines);$i++) {
			$line = $lines[$i];
			$line = ereg_replace('"','',$line);
			list($symbol,$price0,$date,$time,$dchange,$price1,$price2) = split(',',$line);
			
			if ($price1>0 && $dchange!=0) $pchange = round(10000*($dchange)/$price1)/100;
			else $pchange = 0;
			if ($pchange>0) $pchange = "+".$pchange;

			$name = $stocklist[$symbol];
			if (!$name) $name = $symbol;
							
			$quotes[] = array(
				'symbol' => $symbol,
				'price0' => $price0,
				'date' => $date,
				'time' => $time,
				'dchange' => $dchange,
				'price1' => $price1,
				'price2' => $price2,
				'pchange' => $pchange,
				'name' => $name
			);
		}
		return $quotes;
	}

	function getSavedStocks() {
		global $username;
		$stocklist = array();
		$result = $this->db->query("select stocks from pstocks where(username=\"$username\")");
		if ($row = $this->db->fetch_array($result)) {
			$stocks = $row['stocks'];
			$parts = split('&',$stocks);
			for ($i=0;$i<count($parts);$i++) {
				$s = split('=',$parts[$i]);
				$symbol = rawurldecode($s[0]);
				$name = rawurldecode($s[1]);
				if ($symbol) {
					if (!$name) $name = $symbol;
					$stocklist[$symbol] = $name;
				}
			}
		}
		return $stocklist;
	}

	function saveStocks($stocklist) {
		global $username;
		
		while(list($symbol,$name) = each($stocklist)) {
			if ($symbol && $name) {
				$stockstr .= "$symbol=$name";
				if ($i++<count($stocklist)-1) $stockstr .= "&";
			}
		}
		$this->db->query("delete from pstocks where(username=\"$username\")");
		$this->db->query("insert into pstocks VALUES(\"$username\",\"$stockstr\")");
	}
	
	function displayEdit() {
		print '
		
		<script>
		pasteIt = function(symbol,name) {
			document.addstock.newsymbol.value = symbol
			document.addstock.newname.value = name
		}
		</script>
		
		<form action=pstocks.php3>
		<input type=hidden name=command value=deletestock>
		Your Favourite Stocks:
		<p><table border=1>
		<tr><td><b><a href="http://finance.yahoo.com/l" target=_blank>Symbol</a></b></td><td><b>Company Name</b></td><td><b>Delete</b></td></tr>
		';

		$stocklist = $this->getSavedStocks();
		while(list($symbol,$name) = each($stocklist)) {
			print "<tr><td>$symbol</td><td>$name</td><td><input type=radio name=deletestock value='$symbol'></td></tr>";
		}

		print '
		<tr><td colspan=2></td><td><input type=submit value="Delete"></td></tr>
		</table></td></tr></table>
		</form>
		
		<form action=pstocks.php3 name=addstock>
		<input type=hidden name=command value=addstock>
		<table border=1>
		<tr><td><b><a href="http://finance.yahoo.com/l" target=_blank>Symbol</a></b></td><td colspan=2><b>Company Name</b></td></tr>
		<tr><td><input name=newsymbol size=6></td><td><input name=newname size=20></td><td><input type=submit value="Add New Stock"></td></tr>
		</table></td></tr></table>
		</form>
		
		<p>Example Stocks/Markets:
		';
		
		$list = array(
			'Dow Jones Industrial Average' => '^DJI',
			'Nasdaq Composite' => '^IXIC',
			'S&P 500' => '^SPC',
			'Toronto Stock Exchange' => '^TSE',
			'Microsoft' => 'MSFT',
			'RedHat' => 'RHAT',
			'VA Linux' => 'LNUX'
		);
		
		while( list($name,$symbol) = each($list) ) {
			print "<br><a href=\"javascript:pasteIt('$symbol','$name')\">$name</a>";
		}
		
		print '<p><a href=pstocks.php3>&lt;&lt; Back to PStocks</a>';
	}
	
	function doAddStock() {
		global $newsymbol,$newname;
		$newsymbol = rawurlencode($newsymbol);
		$newname = rawurlencode($newname);
		if (!$newname) $newname = $newsymbol;
		
		$stocklist = $this->getSavedStocks();
		
		$newlist = array();
		while(list($symbol,$name) = each($stocklist)) {
			$newlist[rawurlencode($symbol)] = rawurlencode($name);
		}
		$newlist[$newsymbol] = $newname;
		
		$this->saveStocks($newlist);
		
		$this->displayEdit();
	}
	
	function doDeleteStock() {
		global $username,$deletestock;
		$stocklist = $this->getSavedStocks();
		$newlist = array();
		while(list($symbol,$name) = each($stocklist)) {
			if ($symbol!=$deletestock) {
				$newlist[rawurlencode($symbol)] = rawurlencode($name);
			}
		}
		if (count($stocklist)==0) $newlist = array();
		$this->saveStocks($newlist);
				
		$this->displayEdit();
	}
}

?>
