<?
include('dplib.php3');

// DPLib tests

function getFile($value) {
	$file = http_get($value);
	$phtml = html_getPrintableHTML($file);
	print "<form><textarea cols=100 rows=30>$phtml</textarea></form>";
}

function getFormatted($value) {
	$file = http_get($value);
	$html = html_formatTags($file);
	$phtml = html_getPrintableHTML($html);
	print "<form><textarea cols=100 rows=30>$phtml</textarea></form>";
}

function parseForms($value) {
	$file = http_get($value);
	$html = html_formatTags($file);
	$forms = html_parseForms($html);
	
	if (count($forms)==0) {
		debug("no forms found");
	}
	
	for ($i=0;$i<count($forms);$i++) {
			
		$action = $forms[$i]["action"];
		$method = $forms[$i]["method"];
		
		print "<p><b>Form #".$i."</b>:";
		print "<br>action = $action";
		print "<br>method = $method";
		
		$inputs = $forms[$i]["inputs"];
		$c = count($inputs);

		for ($j=0;$j<count($inputs);$j++) {

			$name = $inputs[$j][0];
			$name = chop($name);
			$name = ltrim($name);
			$type = $inputs[$j][1];
			$value = $inputs[$j][2];

			print "<br>input $j -> name=$name type=$type value=$value";
			
		}
	}
}

function saveCookie() {
	$name = 'John Smith';
	$age = 30;
	$gender = 'male';
	
	$info = new CookieSet('info');
	$info->addData('name',$name);
	$info->addData('age',$age);
	$info->addData('gender',$gender);
	$info->save();

	print "
	<p>The CookieSet named \"info\" has been saved with the following values:<p>
	name = $name<br>
	age = $age<br>
	gender = $gender<br>
	";
}

function readCookie() {
	$info = http_getCookieSet('info');
	if ($info) {
		$name = $info->data["name"];
		$age = $info->data["age"];
		$gender = $info->data["gender"];
		
		print "
		<p>The CookieSet named \"info\" contained the following data:<p>
		name = $name<br>
		age = $age<br>
		gender = $gender<br>
		";
	}
	else {
		print 'the CookieSet named "info" does not exist';
	}
}

function deleteCookie() {
	$info = http_getCookieSet('info');
	if ($info) {
		$info->delete();
		print "The CookieSet named \"info\" has been deleted";
	}
	else {
		print 'the CookieSet named "info" does not exist';
	}	
}

function parseTag() {

	// badly formatted tag
	$html = '<  inPUt NAme = \'theName\' extraneous1 type = theTYPE vaLue ="this   is the  VALUE" stYLE    =\'THE style\'  extraneous2>';

	// format so we can see it
	$temp = html_getPrintableHTML($html);  // replaces < with &lt; ...
	print "<p><b>badly formatted tag:</b><br>$temp";

	// reformat tag so it's easier to parse
	$html = html_formatTags($html);
	$temp = html_getPrintableHTML($html);
	print "<p><b>formatted tag:</b><br>$temp<p>";

	// find attributes:
	$attributes = html_parseTagAttributes($html);

	$numatts = count($attributes);
	print "<p><b>Parsed $numatts attributes:</b><br>";

	while( list($name,$value) = each($attributes) ) {
		print "$name = $value <br>";
	}

	/* you can also do this
	
	$name = $attributes['name'];
	print "name = $name <br>";
	
	$type = $attributes['type'];
	print "type = $type <br>";
	
	*/
	
}

if ($test) {
	if (!$value) {
		eval("${test}();");
		die();
	}
	else {
		eval("$test('$value');");
		die();
	}
}
else {
	print '
	<a href="dplib-test.php3?test=parseTag">Parse Tag</a><br>
	<a href="dplib-test.php3?test=saveCookie">save CookieSet</a><br>
	<a href="dplib-test.php3?test=readCookie">read CookieSet</a><br>
	<a href="dplib-test.php3?test=deleteCookie">delete CookieSet</a><br>

	<form name=getfile>
	get file from:<br>
	<input name=file value=http://www.google.com size=30> <input type=button name=submit value=submit onclick=\'document.location.href="dplib-test.php3?test=getFile&value="+document.getfile.file.value\'>
	</form>
		
	<form name=getformatted>
	get formatted file from:<br>
	<input name=file value=http://www.google.com size=30> <input type=button name=submit value=submit onclick=\'document.location.href="dplib-test.php3?test=getFormatted&value="+document.getfile.file.value\'>
	</form>
	
	<form name=parseforms>
	parse FORMs from:<br>
	<input name=file value=http://www.google.com size=30> <input type=button name=submit value=submit onclick=\'document.location.href="dplib-test.php3?test=parseForms&value="+document.getfile.file.value\'>
	</form>
	';
}

?>

