<?

/*

PCalendar 0.1 (May 10, 2000)
a simple multi-user calendar system
http://www.dansteinman.com/php/PCalendar/

Copyright (C) 1999 Dan Steinman (dan@dansteinman.com)

This is free software under the terms of the GNU General Public License

*/

include('dplib.php3');  // Dan's PHP Library
include('class.pcalendar.php3');  // PCalendar Class

// -- DPLib: make a database connection ------------

$mysql = new MySQLDatabase;
$mysql->setDB('localhost','myuser','mypass');
$mysql->select_db('myportal');

// -- DPLib: username password login ------------
$phPortalSettings = http_getCookieSet('phportal');
if ($phPortalSettings) {
	$username = $phPortalSettings->data["username"];
	$password = $phPortalSettings->data["password"];
	$mysql->checkPassword($username,$password,null);
}
else {
	debug("bad username/password");
}
if ($username == "guest") debug("cannot use guest account here");

// -- PCalendar ------------

$calendar = new PCalendar($mysql);

print '<body bgcolor=white>';
print "<b>Calendar for $username</b>";

// -- a functions to display 1 day ------------
function displayDay($timestamp,$events) {
	global $calendar, $username;
	
	$datestr = date("l F j, Y.",$timestamp);
	print "<p><b>Events for:</b> $datestr";
	
	$eventstr = ereg_replace("\n","<br>",$events);
	if ($eventstr) print "<p>$eventstr";
	else print "<p>no events scheduled for this day";
}
function displayDayWeekView($timestamp,$events) {
	global $calendar, $username;
	
	$datestr = date("l F j, Y",$timestamp);
	$d = getdate($timestamp);
	$year = $d["year"];
	$month = $d["mon"];
	$day = $d["mday"];
	
	print "<p><dl><dt><b><a href=\"pcalendar.php3?command=viewday&year=$year&month=$month&day=$day\">$datestr</a>:</b>";
	
	$eventstr = ereg_replace("\n","<br>",$events);
	
	if ($eventstr) print "<dd>$eventstr</dl>";
	else print "<dd></dl>";	
}

// -- a function to print the  ------------
function printForms($year,$month,$day,$events) {
	// -- form to save an event --
	print "
	<p><br><b>Save Events for this day</b>:<br>
	<form action=pcalendar.php3>
	<input type=hidden name=command value=saveevent>
	<input type=hidden name=year value=$year>
	<input type=hidden name=month value=$month>
	<input type=hidden name=day value=$day>
	<textarea name=event rows=6 cols=30 wrap=virtual>$events</textarea>
	<br><input type=submit value='Save Event'>
	</form>
	";
	
	print "<a href=\"pcalendar.php3?command=viewweek&year=$year&month=$month&day=$day\">View This Week's Events</a><br>";
	print "<a href=\"pcalendar.php3?command=viewmonth&year=$year&month=$month\">Browse This Month</a>";
	
	// -- form to view an event --
	$yearm1 = $year-1;
	$yearm2 = $year-2;
	$yearp1 = $year+1;
	$yearp2 = $year+2;
	print "
	<form action=pcalendar.php3>
	<input type=hidden name=command value=viewday>
	<b>Select Day</b>:<br>
	<select name=year>
	<option value=$yearm2>$yearm2
	<option value=$yearm1>$yearm1
	<option value=$year selected>$year
	<option value=$yearp1>$yearp1
	<option value=$yearp2>$yearp2
	</select>
	<select name=month>
	";
	
	$monthnames = array("January","February","March","April","May","June","July","August","September","October","November","December");
	for ($i=0;$i<12;$i++) {
		$mname = $monthnames[$i];
		$mnum = $i+1;
		print "<option value=$mnum";
		if ($month == $mnum) print " selected";
		print ">$mname</option>";
	}
	
	print"
	<select>
	<select name=day>
	";
	for ($i=1;$i<=31;$i++) {
		print "<option value=$i";
		if ($day == $i) print " selected";
		print ">$i</option>";
	}
	print"
	</select>
	<input type=submit value='View Events'>
	<a href='pcalendar.php3'>Go to Today</a>
	</form>
	";
}

// -- PCalendar: custom default page ------------
if (!$command) { 
	$year = date("Y"); // today's date
	$month = date("m");
	$day = date("j");	
	$timestamp = mktime(0,0,0,$month,$day,$year);
	
	$events = $calendar->getEventsTimestamp($timestamp);  // get saved events from db	
	
	displayDay($timestamp,$events);
	printForms($year,$month,$day,$events);
}

// -- PCalendar: view day ------------
else if ($command=="viewday") {
	$events = $calendar->getEvents($year,$month,$day);  // get saved events from db
	$timestamp = mktime(0,0,0,$month,$day,$year);
	
	displayDay($timestamp,$events);
	
	printForms($year,$month,$day,$events);
}

// -- PCalendar: view week ------------
else if ($command=="viewweek") {
	print "<p>Events for this Week";

	$weekevents = $calendar->getWeekEvents($year,$month,$day); // returns array of the 7 calendar events starting on the sunday before this date
		
	for ($i=0;$i<count($weekevents);$i++) {
		$timestamp = $weekevents[$i]["timestamp"];  // the timestamp for that day
		$events = $weekevents[$i]["events"];  // events string

		displayDayWeekView($timestamp,$events);
	}
	print "<p><a href=\"pcalendar.php3?command=viewmonth&year=$year&month=$month\">View This Month</a>";
}

// -- PCalendar: browse month ------------
else if ($command=="viewmonth") {
	$monthevents = $calendar->browseMonth($year,$month); // returns a boolean array of dates with events for this month

	$monthnames = array("January","February","March","April","May","June","July","August","September","October","November","December");	
	$mname = $monthnames[$month-1];
	print "<p>Month View for $mname $year<p>The following dates have scheduled events:<p>";
	
	for ($i=0;$i<count($monthevents);$i++) {
		$timestamp = $monthevents[$i]["timestamp"];  // the timestamp for that day
		$hasevents = $monthevents[$i]["hasevents"];  // boolean true if this date has events
		
		$datestr = date("l F j",$timestamp);
		$d = getdate($timestamp);		
		$day = $d["mday"];
		
		print "<a href=\"pcalendar.php3?command=viewday&year=$year&month=$month&day=$day\">$datestr</a><br>";
	}

	print "
	<form action=pcalendar.php3>
	<input type=hidden name=command value=viewmonth>
	<b>View a Different Month</b>:<br>
	<select name=year>
	<option value=$yearm2>$yearm2
	<option value=$yearm1>$yearm1
	<option value=$year selected>$year
	<option value=$yearp1>$yearp1
	<option value=$yearp2>$yearp2
	</select>
	<select name=month>
	";
	
	for ($i=0;$i<12;$i++) {
		$mname = $monthnames[$i];
		$mnum = $i+1;
		print "<option value=$mnum";
		if ($month == $mnum) print " selected";
		print ">$mname</option>";
	}
	print"
	</select>
	<input type=submit value='View Month'>
	</form>
	";
}

// -- PCalendar: save an event ------------
else if ($command=="saveevent") {
	$calendar->saveEvent($year,$month,$day,$event);
	
	$timestamp = mktime(0,0,0,$month,$day,$year);
	$events = $calendar->getEventsTimeStamp($timestamp);  // get saved events from db
	displayDay($timestamp,$events);
	printForms($year,$month,$day,$events);
}

?>
